(function (exports) {
'use strict';

// Pointer records are the opposite of A and AAAA and are
// used in Reverse Map zone files to map an IP address (IPv4 or IPv6)
// to a host name.

// FORMAT:
// ame ttl  class   rr     name
// 15         IN     PTR    www.example.com.

var unpackLabels = exports.DNS_UNPACK_LABELS || require('./dns.unpack-labels.js').DNS_UNPACK_LABELS;
exports.DNS_TYPE_PTR = function (ab, pack, record) {
    record.data = unpackLabels(new Uint8Array(ab), record.rdstart, { byteLength: 0, cpcount: 0, labels: [], name: '' }).name;
    return record;
};
}('undefined' !== typeof window ? window : exports));
